/**********************************************************************
Copyright (c) 2006 Travis Reeder and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
    ...
**********************************************************************/
package org.datanucleus.sql4o;

/**
 * 
 */
public class ClassRef
{
    private String className;

    private String alias;

    public ClassRef(String className)
    {
        this(className, null);
    }

    public ClassRef(String className, String alias)
    {
        // if .NET query, might be surrouned by quotes, eg: FROM 'Quizlet.Question, Quizlet.Framework'
        this.className = className;
        this.alias = alias;
    }

    public String toString()
    {
        String ret = className;
        if (alias != null)
            ret += " " + alias;
        return ret;
    }

    public String getClassName()
    {
        return className.replaceAll("'", "");
    }

    public String getAlias()
    {
        return alias;
    }
}