/**********************************************************************
Copyright (c) 2006 Travis Reeder and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
    ...
**********************************************************************/
package org.datanucleus.sql4o.parser;


import java.util.List;

import org.datanucleus.sql4o.query.Select;
import org.datanucleus.sql4o.query.SqlQuery;

/**
 * 
 */
public class SelectBuilder implements Builder
{
    final String keyword = "SELECT";

    public String getKeyword()
    {
        return keyword;
    }

    public void build(SqlQuery sq, List<String> expr, List<String> quotedStrings)
    {
        Select select = new Select();
        // select is just a list of fields separated by commas, not necessarily by spaces, so lets split further by
        // commas
        List<String> values = SqlParser.separateCommas(expr, false);

        select.setFields(values);
        sq.setSelect(select);
    }
}