/**********************************************************************
Copyright (c) 2006 Travis Reeder and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
    ...
 **********************************************************************/
package org.datanucleus.sql4o.query;


import java.util.List;
import java.util.ArrayList;

import org.datanucleus.sql4o.ClassRef;

/**
 * 
 */
public class From
{
    private List<ClassRef> classRefs = new ArrayList<ClassRef>();

    public void addClass(String className)
    {
        classRefs.add(new ClassRef(className));
    }

    public void addClass(String className, String alias)
    {
        classRefs.add(new ClassRef(className, alias));
    }

    public String toString()
    {
        StringBuffer ret = new StringBuffer("FROM ");
        for (int i = 0; i < classRefs.size(); i++)
        {
            ClassRef field = classRefs.get(i);
            if (i > 0)
            {
                ret.append(", ");
            }
            ret.append(field);
        }
        return ret.toString();
    }

    public List<ClassRef> getClassRefs()
    {
        return classRefs;
    }
}
