/**********************************************************************
Copyright (c) 2006 Travis Reeder and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
    ...
**********************************************************************/
package org.datanucleus.sql4o.query;

import org.datanucleus.sql4o.SqlStatement;

/**
 * 
 */
public class SqlQuery extends SqlStatement
{
    private Select select;

    private From from;

    private Where where;

    private OrderBy orderBy;

    public void setSelect(Select select)
    {
        this.select = select;
    }

    public void setFrom(From from)
    {
        this.from = from;
    }

    public String toString()
    {
        StringBuffer buff = new StringBuffer();
        if (select != null)
        {
            buff.append(select);
        }
        if (from != null)
        {
            if (select != null)
                buff.append(" ");
            buff.append(from);
        }
        if (where != null)
        {
            buff.append(" ").append(where);
        }
        if (orderBy != null)
        {
            buff.append(" ").append(orderBy);
        }
        return buff.toString();
    }

    public void setWhere(Where where)
    {
        this.where = where;
    }

    public Select getSelect()
    {
        return select;
    }

    public From getFrom()
    {
        return from;
    }

    public Where getWhere()
    {
        return where;
    }

    public void setOrderBy(OrderBy orderBy)
    {
        this.orderBy = orderBy;
    }

    public OrderBy getOrderBy()
    {
        return orderBy;
    }
}
